#include "Keyhole.h"

void setup(void)
{
  Serial.begin(9600);
}

unsigned long t0, t1;
#define TEST(TYPE, NAME)   static TYPE NAME; k.variable(#NAME, NAME, k.plotterMode ? VARIABLE_SILENT : VARIABLE_VERBOSE);

void loop(void)
{
  KEYHOLE k;
  if(k.begin(micros()))
  {
    k.command("dummy1"); // do nothing, but let's see how long it takes
    TEST(bool, b);
    TEST(char, c); // Note: char is considered signed by some microprocessor architectures and unsigned by others
    TEST(int8_t, i8);
    TEST(uint8_t, ui8);
    TEST(unsigned char, uc);
    TEST(int, i);
    TEST(unsigned int, ui);
    TEST(short, h);
    TEST(unsigned short, uh);
    TEST(long, l);
    TEST(unsigned long, ul);
    TEST(float, f);
    TEST(double, d);
    if(!k.plotterMode) { TEST(String, s); }
 
    k.variable("t0", t0, VARIABLE_READ_ONLY);
    k.variable("t1", t1, VARIABLE_READ_ONLY);
    if(k.command("plot")) k.plotterMode = !k.plotterMode;
    if(k.command("auto")) k.autoSeconds = ( k.autoSeconds ? 0.0 : 1.0 );
    k.command("dummy2"); // do nothing, but let's see how long it takes
    
    k.end();
    t1 = k.elapsed();
  }
  else t0 = k.elapsed();
  
}
